DCMTK: dcmtk::log4cplus::PatternLayout Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
List of all members
dcmtk::log4cplus::PatternLayout Class Reference

A flexible layout configurable with pattern string. More...

Inheritance diagram for dcmtk::log4cplus::PatternLayout:

## Detailed Description

A flexible layout configurable with pattern string.

The goal of this class is to format a InternalLoggingEvent and return the results as a string. The results depend on the conversion pattern.

The conversion pattern is closely related to the conversion pattern of the printf function in C. A conversion pattern is composed of literal text and format control expressions called conversion specifiers.

You are free to insert any literal text within the conversion pattern.

Each conversion specifier starts with a percent sign (%%) and is followed by optional format modifiers and a conversion character. The conversion character specifies the type of data, e.g. Logger, LogLevel, date, thread name. The format modifiers control such things as field width, padding, left and right justification. The following is a simple example.

Let the conversion pattern be "%-5p [%t]: %m%n" and assume that the log4cplus environment was set to use a PatternLayout. Then the statements ``

    Logger root = Logger.getRoot();
    DCMTK_LOG4CPLUS_DEBUG(root, "Message 1");
    DCMTK_LOG4CPLUS_WARN(root, "Message 2");

would yield the output ``

    DEBUG [main]: Message 1
    WARN  [main]: Message 2

Note that there is no explicit separator between text and conversion specifiers. The pattern parser knows when it has reached the end of a conversion specifier when it reads a conversion character. In the example above the conversion specifier "%-5p" means the LogLevel of the logging event should be left justified to a width of five characters.

The recognized conversion characters are

Conversion Character | Effect
b | Used to output file name component of path name. E.g. `main.cxx` from path `../../main.cxx`.
c | Used to output the logger of the logging event. The logger conversion specifier can be optionally followed by precision specifier, that is a decimal constant in brackets. If a precision specifier is given, then only the corresponding number of right most components of the logger name will be printed. By default the logger name is printed in full. For example, for the logger name "a.b.c" the pattern c{2} will output "b.c".
d | Used to output the date of the logging event in UTC. The date conversion specifier may be followed by a date format specifier enclosed between braces. For example, %d{%H:%M:%s} or %d{%d %b %Y %H:%M:%s}. If no date format specifier is given then %d{%d %m %Y %H:%M:%s} is assumed. The Following format options are possible: %a – Abbreviated weekday name %A – Full weekday name %b – Abbreviated month name %B – Full month name %c – Standard date and time string %d – Day of month as a decimal(1-31) %H – Hour(0-23) %I – Hour(1-12) %j – Day of year as a decimal(1-366) %m – Month as decimal(1-12) %M – Minute as decimal(0-59) %p – Locale's equivalent of AM or PM %q – milliseconds as decimal(0-999) – Log4CPLUS specific %Q – fractional milliseconds as decimal(0-999.999) – Log4CPLUS specific %S – Second as decimal(0-59) %U – Week of year, Sunday being first day(0-53) %w – Weekday as a decimal(0-6, Sunday being 0) %W – Week of year, Monday being first day(0-53) %x – Standard date string %X – Standard time string %y – Year in decimal without century(0-99) %Y – Year including century as decimal %Z – Time zone name %% – The percent sign Lookup the documentation for the `strftime()` function found in the `<ctime>` header for more information.
D | Used to output the date of the logging event in local time. All of the above information applies.
F | Used to output the file name where the logging request was issued. NOTE Unlike log4j, there is no performance penalty for calling this method.
h | Used to output the hostname of this system (as returned by gethostname(2)). NOTE The hostname is only retrieved once at initialization.
H | Used to output the fully-qualified domain name of this system (as returned by gethostbyname(2) for the hostname returned by gethostname(2)). NOTE The hostname is only retrieved once at initialization.
l | Equivalent to using "%F:%L" NOTE: Unlike log4j, there is no performance penalty for calling this method.
L | Used to output the line number from where the logging request was issued. NOTE: Unlike log4j, there is no performance penalty for calling this method.
m | Used to output the application supplied message associated with the logging event.
M | Used to output function name using `FUNCTION` or similar macro. NOTE The `FUNCTION` macro is not standard but it is common extension provided by all compilers (as of 2010). In case it is missing or in case this feature is disabled using the `DCMTK_LOG4CPLUS_DISABLE_FUNCTION_MACRO` macro, M expands to an empty string.
n | Outputs the platform dependent line separator character or characters.
p | Used to output the LogLevel of the logging event.
P | Used to output the first character of the LogLevel of the logging event. NOTE: This pattern has been added to log4cplus.
r | Used to output milliseconds since program start of the logging event.
t | Used to output the name of the thread that generated the logging event.
T | Used to output alternative name of the thread that generated the logging event.
i | Used to output the process ID of the process that generated the logging event.
x | Used to output the NDC (nested diagnostic context) associated with the thread that generated the logging event.
"%%" | The sequence "%%" outputs a single percent sign.

By default the relevant information is output as is. However, with the aid of format modifiers it is possible to change the minimum field width, the maximum field width and justification.

The optional format modifier is placed between the percent sign and the conversion character.

The first optional format modifier is the left justification flag which is just the minus (-) character. Then comes the optional minimum field width modifier. This is a decimal constant that represents the minimum number of characters to output. If the data item requires fewer characters, it is padded on either the left or the right until the minimum width is reached. The default is to pad on the left (right justify) but you can specify right padding with the left justification flag. The padding character is space. If the data item is larger than the minimum field width, the field is expanded to accommodate the data. The value is never truncated.

This behavior can be changed using the maximum field width modifier which is designated by a period followed by a decimal constant. If the data item is longer than the maximum field, then the extra characters are removed from the beginning of the data item and not from the end. For example, it the maximum field width is eight and the data item is ten characters long, then the first two characters of the data item are dropped. This behavior deviates from the printf function in C where truncation is done from the end.

Below are various format modifier examples for the logger conversion specifier.

Format modifier | left justify | minimum width | maximum width | comment
%20c | false | 20 | none | Left pad with spaces if the logger name is less than 20 characters long.
%-20c | true | 20 | none | Right pad with spaces if the logger name is less than 20 characters long.
%.30c | NA | none | 30 | Truncate from the beginning if the logger name is longer than 30 characters.
%20.30c | false | 20 | 30 | Left pad with spaces if the logger name is shorter than 20 characters. However, if logger name is longer than 30 characters, then truncate from the beginning.
%-20.30c | true | 20 | 30 | Right pad with spaces if the logger name is shorter than 20 characters. However, if logger name is longer than 30 characters, then truncate from the beginning.

Below are some examples of conversion patterns.

"%r [%t] %-5p %c %x - %m%n"

  This is essentially the TTCC layout.

"%-6r [%15.15t] %-5p %30.30c %x - %m%n"

  Similar to the TTCC layout except that the relative time is right padded if less than 6 digits, thread name is right padded if less than 15 characters and truncated if longer and the logger name is left padded if shorter than 30 characters and truncated if longer.

The above text is largely inspired from Peter A. Darnell and Philip E. Margolis' highly recommended book "C -- a Software Engineering Approach", ISBN 0-387-97389-3.

The documentation for this class was generated from the following file:

- oflog/include/dcmtk/oflog/layout.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2